; Cwiczenie nr 3 na laboratoria z Asemblerow
; (C) 2000, 2001 Marcin Owsiany
; Program rysujacy wielokaty w trybie graficznym
JUMPS
.model Small,Stdcall

.stack 100h

.data
	helptxt		db "Uzycie programu: f plik.wej", 13, 10
			db "Gdzie plik.wej to plik z danymi wejsciowymi.$"
	erropen		db "Nie udalo sie otworzyc pliku.$"
	errclose	db "Nie udalo sie zamknac pliku.$"
	erread		db "Nie udalo sie czytac z pliku.$"
	errdata		db "Niepoprawne dane wejsciowe.$"
	errlseek	db "Nie udalo sie przesunac pozycji w pliku.$"
	errtoobig	db "Wspolrzedna jest za duza.$"
	errres		db "Nieprawidlowa rozdzielczosc.", 13, 10
			db "Rozdzielczosc musi byc liczba 640 lub 320.$"
	errnof		db "Po rozdzielczosci musi byc podana w osobnych liniach conajmniej jeden wielokat.$"
	errnopoints	db "Po kolorze musi byc podany conajmniej jeden punkt.$"
	errinvcol	db "Nieprawidlowy kod koloru.$"
	errxtoobig	db "Wspolrzedna x jest za duza.$"
	errytoobig	db "Wspolrzedna y jest za duza.$"
	ofmsg		db "Otwieranie pliku.$"
	clmsg		db "Zamykanie pliku.$"
	resgetmsg	db "Pobieranie rozdzielczosci.$"
	pgetmsg		db "Pobieranie wspolrzednych punktow wielokata.$"

	endl		db '', 13, 10, '$'		; CL+LF
	srcfnam		db 13 dup (0)	; dzieki temu nazwa pliku bedzie zakonczona '0'
	srcfh		dw ?
	tmpnbuf		db 7  dup (0)
	maxx		dw ?
	maxy		dw ?
	firstx		dw ?
	firsty		dw ?
	lastx		dw ?
	lasty		dw ?
	thisx		dw ?
	thisy		dw ?
	tlastx		dw ?
	tlasty		dw ?
	tthisx		dw ?
	tthisy		dw ?
	xdif		dw ?
	ydif		dw ?
	swapped		dw 0
	dif1		dw ?
	dif2		dw ?
	dif3		dw ?
	dif4		dw ?
	tfcolor		dw ?
	tmpnum		dw ?
	sfpos		dw 0
	spc		db ' '
	ingfxmode	dw 0

; pare stalych
	ENTRD		dw 1
	SPCD		dw 2
	NTHNG		dw 3
	IMMD		dw 4

	C_WHITE		dw 15
	C_RED		dw 4
	C_GREEN		dw 2
	C_BLUE		dw 1


.code
start:
		mov ax, @data
		mov ds, ax
; parametry programu
		xor  cx, cx
		mov  cl, es:[80h]
		cmp  cx, 0				; jesli brak opcji...
		jne  exopt
		mov  dx, offset helptxt
		call helpmsg				; ...to zglos blad
exopt:	call strcpy, offset srcfnam, 82h	; pobierz nazwe pliku zrodlowego
							mov  dx, offset ofmsg
							call debugmsg
; otworz plik wejsciowy
		call open,   offset srcfnam		; otworz plik wej.
							mov  dx, offset resgetmsg
							call debugmsg
; odczyt rozdzielczosci
		call readnum, 0013
		mov  ax, tmpnum
		cmp  ax, 640
		jne  restry1
		mov  ax, 639				; 640x480
		mov  maxx, ax
		mov  ax, 479
		mov  maxy, ax
		jmp  reschosen
restry1:	cmp  ax, 320
		jne  resfail
		mov  ax, 319				; 320x200
		mov  maxx, ax
		mov  ax, 199
		mov  maxy, ax
		jmp  reschosen
resfail:	mov  dx, offset errres			; nieprawidlowa
		call helpmsg
reschosen:	dec  sfpos				; cafamy o jeden znak
		call lseek				; przeczytany przez readnum
		call discover				; czy jest nastepna linia?
		cmp  ax, ENTRD
		je   arep
		mov  dx, offset errnof
		call helpmsg
arep:
	nextfig:
						;	mov dx, offset pgetmsg
						;	call debugmsg
			call getsetcolor		; ustaw kolor
			call discover			; czy jest choc 1 punkt?
			cmp  ax, SPCD
			jne  emptyfig

			call getx			; pobierz jego wspolrzedne
			mov  ax, tmpnum			; i zapamietaj
			mov  firstx, ax
			mov  lastx, ax
			call gety
			mov  ax, tmpnum
			mov  firsty, ax
			mov  lasty, ax

		trynxtpnt:	call discover
				cmp  ax, SPCD		; jesli jest jeszcze jeden punkt
				jne  nonxtpnt
		
				call getx		; pobierz jego wspolrzedne
				mov  ax, tmpnum		; i zapamietaj
				mov  thisx, ax
				call gety
				mov  ax, tmpnum
				mov  thisy, ax

				push ax
				mov  ax, ingfxmode
				cmp  ax, 1
				pop  ax
				je   dodrawl
				call entergfxmode

		dodrawl:	call drawline		; narysuj odcinek

				mov  ax, thisx		; zapamietaj jego wspolzedne jako poprzednie
				mov  lastx, ax
				mov  ax, thisy
				mov  lasty, ax

				jmp  trynxtpnt

	nonxtpnt:	push ax
			mov  ax, firstx
			mov  thisx, ax
			mov  ax, firsty
			mov  thisy, ax

			call drawline

			pop ax
			cmp ax, ENTRD
			je  nextfig			; jest jeszcze jedna figura

zaczekaj:	mov  ah, 01
		int  16h
		jz   zaczekaj

; wroc do trybu tekstowego
		call leavegfxmode
		mov  dx, offset clmsg
		call debugmsg
; zamknij plik wejsciowy
		call close,  srcfh
; i zakoncz program
		mov  ax, 4c00h
		int  21h

emptyfig:	mov  dx, offset errnopoints
		call helpmsg

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; inne procedury

; przeczytaj z pliku tekstowego jeden znak
; zwraca 3, jesli byl to koniec pliku
; zwraca 2, jesli byla to spacja
; zwraca 1, jesli byl to CR+LF
; zwraca 0, jesli byl to inny znak
sentry proc
		push bx
		push cx
		push dx
		xor  ax, ax
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 1			; jeden bajt
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		jc   pusto			; jesli sie nie udalo, zwroc EOF
		cmp  ax, 1
		jne  pusto
		mov  bx, offset tmpnbuf		; potrzebne do indeksowania
		mov  al, ds:[bx]
		cmp  al, ' '			; jesli spacja
		je   whitechar			; zwroc 2
		cmp  al, 13			; jesli nie CR
		jne  otherchar			; zwroc 0
		xor  ax, ax			; jesli CR, to sprawdz czy LF
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 1			; jeden bajt
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		jc   pusto			; jesli sie nie udalo, zwroc EOF
		mov  bx, offset tmpnbuf		; potrzebne do indeksowania
		mov  al, ds:[bx]
		cmp  al, 10			; jesli nie LF
		jne  pusto			; jesli CR+X (gdzie X!=LF), zwroc EOF
		mov  ax, 1			; jesli CR+LF, zwracamy 1
		inc  sfpos
		inc  sfpos
		call lseek
		jmp  endsntry

otherchar:	xor  ax, ax			; w przeciwnym wypadku zwroc 0
		call lseek
		jmp  endsntry

pusto:		mov  ax, 3
		jmp  endsntry

whitechar:	mov  ax, 2
		inc  sfpos
		call lseek

endsntry:	pop  dx
		pop  cx
		pop  bx
		ret
sentry endp

; sprawdz, co jest dalej w pliku tekstowym
; zwraca IMMD, jesli dane byly od razu
; zwraca ENTERD, jesli byly dane w nastepnej linii
; zwraca SPCD, jesli byly dane po bialych znakach
; zwraca NOTHING, jesli byl to koniec pliku
discover proc
		push bx
		mov  bx, IMMD
dscntry:	call sentry			; jesli nastepnym znakiem
		cmp  ax, 3			; nie jest koniec pliku
		je   dsceof
		cmp  ax, 2			; a jest spacja
		jne  dsctry1
		mov  bx, SPCD			;  - zapamietaj, ze byla to spacja
dsctry1:	cmp  ax, 1			; a jest CR+LF
		jne  enddscvr
		mov  bx, ENTRD			;  - zapamietaj, ze byl to enter
		jmp  dscntry
dsceof:		mov  bx, NOTHING
enddscvr:	mov  ax, bx
		pop  bx
		ret
discover endp

getx proc
		push ax
		call readnum, ','
		mov  ax, tmpnum
		cmp  ax, maxx
		jg   getxtoobig
;		mov  thisx, ax
		pop  ax
		ret
getxtoobig:	mov  dx, offset errxtoobig
		call helpmsg
getx endp

gety proc
		push ax
		call readnum, ' '
		mov  ax, tmpnum
		cmp  ax, maxy
		jg   getytoobig
;		mov  thisy, ax
		pop  ax
		dec  sfpos
		call lseek
		ret
getytoobig:	mov  dx, offset errytoobig
		call helpmsg
gety endp

; za Bresenhamem :-)
drawline proc
		push ax
		push bx
		push cx
		push dx
		push si
		push di
		mov  swapped, 0
		mov  ax, lastx
		mov  bx, lasty
		mov  si, thisx
		mov  di, thisy
		mov  tlastx, ax
		mov  tlasty, bx
		sub  ax, si
		cwd
		xor  ax, dx
		sub  ax, dx
		mov  xdif, ax
		mov  ax, bx
		sub  ax, di
		cwd
		xor  ax, dx
		sub  ax, dx
		mov  ydif, ax
		cmp  ax, xdif
		jle  noswap
		mov  swapped, 1
		mov  xdif, ax
		mov  ax, tlastx
		mov  bx, tlasty
		mov  tlastx, bx
		mov  tlasty, ax
		mov  ax, si
		mov  si, di
		mov  di, ax
noswap:		mov  tthisx, si
		mov  tthisy, di
		mov  ax, tlastx
		cmp  ax, tthisx
		jle  noswap2
		mov  ax, tthisy
		mov  bx, tlasty
		mov  tlasty, ax
		mov  tthisy, bx
		mov  ax, tthisx
		mov  bx, tlastx
		mov  tlastx, ax
		mov  tthisx, bx
noswap2:	mov  ax, tthisy
		sub  ax, tlasty
		mov  ydif, ax
		shl  ax, 1
		mov  dif2, ax
		sub  ax, xdif
		mov  dif1, ax
		mov  ax, ydif
		sub  ax, xdif
		shl  ax, 1
		mov  dif3, ax
		mov  ax, ydif
		add  ax, xdif
		shl  ax, 1
		mov  dif4, ax
LineLp:		cmp  swapped, 0
		jne  noswap3
		mov  ax, tlastx
		mov  bx, tlasty
		jmp  DL1
noswap3:	mov  ax, tlasty
		mov  bx, tlastx
DL1:		call putpixel, ax, bx
		mov  ax, tlastx
		cmp  ax, tthisx
		jge  drwlend
		inc  tlastx
		cmp  dif1, 0
		jge  DL2
		cmp  ydif,0
		jge  DL3
		dec  tlasty
		mov  ax, dif4
		jmp  DL4
DL2:		cmp  ydif, 0
		jle  DL3
		inc  tlasty
		mov  ax, dif3
		jmp  DL4
DL3:		mov  ax, dif2
DL4:		add  dif1, ax
		jmp  LineLp
drwlend:	pop  di
		pop  si
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
drawline endp

entergfxmode proc
		push ax
		push bx
		xor  ax, ax
		mov  al, 13h		; zakladamy, ze 320
		mov  bx, maxx
		inc  bx
		cmp  bx, 640
		jne  switchgfxm
		mov  al, 12h		; ew. zmiana
switchgfxm:	int  10h
		mov  ingfxmode, 1
		pop  bx
		pop  ax
		ret
entergfxmode endp

leavegfxmode proc
		push ax
		xor  ax, ax
		mov  al, 3
		int  10h
		mov  ingfxmode, 0
		pop  ax
		ret
leavegfxmode endp

getsetcolor proc
		push bx
		push cx
		push dx
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 1			; jeden bajt
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		jc   gscpusto			; jesli sie nie udalo, zwroc EOF
		mov  bx, offset tmpnbuf		; potrzebne do indeksowania
		mov  al, ds:[bx]
		cmp  al, 'B'			; jesli bialy
		jne  gsc1
		mov  ax, C_WHITE
		jmp  endgsc
gsc1:		cmp  al, 'C'			; jesli czerwony
		jne  gsc2
		mov  ax, C_RED
		jmp  endgsc
gsc2:		cmp  al, 'Z'			; jesli zielony
		jne  gsc3
		mov  ax, C_GREEN
		jmp  endgsc
gsc3:		cmp  al, 'N'			; jesli niebieski
		jne  invalidcolor
		mov  ax, C_BLUE
endgsc:		mov  tfcolor, ax
		inc  sfpos
		call lseek
		pop  dx
		pop  cx
		pop  bx
		ret
gscpusto:	mov  dx, offset errnof
		call helpmsg
invalidcolor:	mov  dx, offset errinvcol
		call helpmsg
getsetcolor endp

putpixel proc iks:WORD, igrek:WORD
		mov  ax, tfcolor
		mov  ah, 0ch
		mov  bh, 0
		mov  cx, iks
		mov  dx, igrek
		sub  dx, maxy			; zmiana cwiartki
		neg  dx
		int  10h
		ret
putpixel endp

; wczytuje liczbe z pliku wejsciowego do zmienniej tmpnum
; jako parametr - znak, ktorym moze sie konczyc dana liczba (CR lub ' ')
readnum proc ech:WORD
		push ax
		push bx
		push cx
		push dx
		push di				; zapis rejestrow
		xor  ax, ax
		mov  tmpnum, ax			; zeruj tmpnum
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 4			; cztery bajty
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		jc   bladczytania		; jesli sie nie udalo wypisz blad
		mov  bx, offset tmpnbuf		; potrzebne do indeksowania
		mov  cx, ax			; licznik petli
		xor  di, di			; offset znaku przy szukaniu spacji
rdnextchar:	cmp  byte ptr ds:[bx+di], '0'	; jesli znakiem
		jl   endofdigits		;   nie byla
		cmp  byte ptr ds:[bx+di], '9'	;   cyfra to znaczy
		jg   endofdigits		;   ze mamy cala liczbe
		inc  di				; zwiekszenie offsetu
		loop rdnextchar			; i ponowne wykonanie petli
endofdigits:	cmp  di, 0			; jesli nie bylo zadnych cyfr
		je   rdnerror			; lub jesli liczba
		push ax
		xor  ax, ax
		mov  ax, ech
		cmp  byte ptr ds:[bx+di], al	; nie byla zakonczona
		pop  ax
		jne  rdnerror			; odpowiednim znakiem
		jmp  therewasdigit
rdnerror:	push ax
		mov  ax, ech
		cmp  al, ' '
		jne  nohope
		mov  al, byte ptr ds:[bx+di]
		cmp  al, 13
		jne  nohope
		pop  ax
		jmp  therewasdigit
nohope:		mov  dx, offset errdata		; to wypisz blad
		call helpmsg
	; w tym momencie w di jest offset ostatniej cyfry + 1
	; wiec jest to stosowny moment do ustawienia pozycji pliku
	; zeby mozna bylo odczytac bezproblemowo nastepna liczbe
therewasdigit:	inc  di
		add  sfpos, di
		call lseek
		dec  di				; usuwamy ^^^ ta jedynke
		;dec  di	to co dodalem - nie, zeby petla dzialala ok
		mov  cx, di			; licznik petli konwersji
		mov  dl, 1			; mnoznik dla jednosci
atoi:		mov  al, byte ptr ds:[bx+di-1]	; pobieramy cyfre jako znak
		sub  al, '0'			; zamieniamy ja na bajt
		mul  dl;*al			; mnozymy stosownie do pozycji
		add  tmpnum, ax			; i dodajemy do calej liczby
		push ax
		mov  al, dl
		mov  dl, 10
		mul  dl				; zwiekszamy mnoznik o rzad
		mov  dl, al
		pop  ax
		dec  di				; przesuwamy pozycje
		loop atoi			; konwertujemy dalej
		xor  ax, ax
		mov  ax, 640			; sprawdzamy czy
		cmp  tmpnum, ax			; odczytana liczba
		jg   rnetoobig			; nie jest wieksza niz 640
		pop  di
		pop  dx
		pop  cx
		pop  bx
		pop  ax				; przywracamy rejestry
		ret				; i wracamy
bladczytania:	mov  dx, offset erread		; wypisywanie bledu
		call helpmsg
rnetoobig:	mov  dx, offset errtoobig	; liczba za duza
		call helpmsg
readnum endp


; ustawia pozycje w pliku wejsciowym na ta podana w parametrze
lseek proc
		push ax
		push bx
		push cx
		push dx
		xor  cx, cx
		mov  dx, sfpos		; offset
		mov  ah, 42h		; lseek()
		mov  al, 0		; origin = BOF
		mov  bx, srcfh		; plik wejsciowy
		int  21h
		jc   lseekerr
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
lseekerr:	mov  dx, offset errlseek
		call helpmsg
lseek endp

; wypisuje string wskazywany przez dx
write proc
		push ax
		mov  ah, 9
		int  21h
		pop  ax
		ret
write endp

; wypisuje string wskazywany przez bx o dlugosci w cx
mywrite proc
		push ax
		push si
		push dx
		mov  ah, 2
		xor  si, si
mwl:		mov  dl, ds:[bx+si]
		int  21h
		inc  si
		loop mwl
		pop  dx
		pop  si
		pop  ax
		ret
mywrite endp

; pomoc - ustaw dx na komunikat bledu
helpmsg proc
		push dx
		mov  dx, offset endl
		call write
		pop  dx
		call write
		mov  dx, offset endl
		call write
		mov  ah, 4ch
		mov  al, 1
		int  21h
helpmsg endp

; informacja - ustaw dx na komunikat
debugmsg proc
		call write
		mov  dx, offset endl
		call write
		ret
debugmsg endp

strcpy proc dstoff:WORD, srcoff:WORD
		push di
		push bx
		mov  bx, srcoff
		xor  di, di			; zeruj licznik
snch:		mov  bx, srcoff
		mov  al, byte ptr es:[bx+di]	; pobierz znak
		cmp  al, ' '			; jesli jest to spacja
		jz   scend			; 	to koncz
		cmp  al, 13			; jesli koniec opcji (CR)
		jz   scend			;	to tez koncz
		mov  bx, dstoff
		mov  byte ptr ds:[bx+di], al	; w przeciwnym wypadku skopiuj znak
		inc  di				; zwieksz licznik
		jmp  snch			; i jeszcze raz
scend:		cmp  di, 0			; jesli string byl pusty
		jne  wasstr
		call helpmsg			; 	to zglos blad
wasstr:		mov  ax, di			; zwracamy dlugosc licznika w ax
		pop  bx
		pop  di
		inc  ax				; przeskakujemy spacje
		ret
strcpy endp

open proc fnam:WORD
		push ax
		push cx
		push dx
		xor  ax, ax		; O_RONLY
		mov  ah, 3dh		; open()
		mov  al, 0
		mov  dx, fnam
		int  21h
		jnc  openok		; jesli sie nie udalo to
		lea  dx, erropen	; zglos
		call helpmsg		; blad
openok:		mov  srcfh, ax
		pop  dx
		pop  cx
		pop  ax
		ret
open endp

close proc fh:WORD
		push dx
		xor  ax, ax
		mov  ah, 3eh		; close()
		mov  bx, fh
		int  21h
		jnc  closeok		; jesli sie nie udalo
		lea  dx, errclose	; to zglos
		call helpmsg		; blad
closeok:	pop  dx
		ret
close endp

end start
